/***********************************************************************************/
/**	\file				Receiver.h
**	\brief				Header File zur Klasse Receiver
*************************************************************************************
**	Autor:				Christian Roesch
**
**	Erstelldatum:		03.04.2002
**	letzte Aenderung:	03.04.2002
*************************************************************************************
**	Diese Klasse ist fr das Empfangen und zusammensetzen der Nachrichten zustndig.
************************************************************************************/

#ifndef _Receiver_H
#define _Receiver_H

// includes
#include <stdio.h>
#include <conio.h>
#include <vector>

#include "..\common\RNPacket.h"
#include "..\common\RNSocket.h"
#include "..\common\MessageGeneric.h"

//! Typdefinition fr den Buffer der Fragmente
typedef std::vector <MessageCharFragment*> FragVec;

// Klassen-Deklaration

/***********************************************************************************/
/** \brief	Receiver ist der Empfnger 
*************************************************************************************
**	Diese Klasse empfngt die CharFragments und setzt sie wieder zu einem gesamten
**  Text zusammen. Dieser wird dann natrlich ausgegeben.
************************************************************************************/

class	Receiver
{
public:
	Receiver(int iPort);
	~Receiver(void);

	void	run(void);

protected:

private:

	int		findPacketNr(FragVec &pmcfvecSrc, DWORD dwPacketNr);
	void	showFrags(FragVec &pmcfvecSrc, bool bShow=true);

	static	RNPRESULT StaticMessageHandler(	void*	pvoidUserContext,
											void*	pvoidPacket,
											WORD	wSize);

	RNPRESULT MessageHandler(	void*	pvoidPacket,
								WORD	wSize);

	
	//! Buffer fr alle neu erhaltenen Textfragmente
	FragVec m_pmcfvecNew;

	//! Buffer fr die bereits geordneten Textfragmente
	FragVec m_pmcfvecOrdered;

	//! Port, das fr die Verbindung genutzt wird
	int		m_iPort;
};

#endif//_Receiver_H

class	Receiver;


/************************************************************************************
**	Ende der Datei:		Receiver.h
************************************************************************************/
