/***********************************************************************************/
/**	\file				Sender.h
**	\brief				Header File zur Klasse Sender
*************************************************************************************
**	Autor:				Christian Roesch
**
**	Erstelldatum:		04.04.2002
**	letzte Aenderung:	04.04.2002
*************************************************************************************
**	Diese Klasse ist fr das Zerschneiden und Verschicken der Nachrichten zustndig.
************************************************************************************/

#ifndef _Sender_H
#define _Sender_H

// includes
#include <stdio.h>
#include <conio.h>

#include "..\common\RNPacket.h"
#include "..\common\RNSocket.h"
#include "..\common\MessageGeneric.h"

// Klassen-Deklaration

/***********************************************************************************/
/** \brief	Sender zerlegt und verschickt Textfiles
*************************************************************************************
**	Sender verbindet sich zu einer IP und schickt dann ein (zerstckeltes) Textfile
**  an den Receiver.
************************************************************************************/

class	Sender
{
public:
	Sender(int iPort);

	void	run(void);

protected:

private:
	static	RNPRESULT StaticMessageHandler(	void*	pvoidUserContext,
											void*	pvoidPacket,
											WORD	wSize);

	RNPRESULT MessageHandler(	void*	pvoidPacket,
								WORD	wSize);

	//! Port, das fr die Verbindung genutzt wird
	int		m_iPort;
};

#endif//_Sender_H

class	Sender;


/************************************************************************************
**	Ende der Datei:		Sender.h
************************************************************************************/
