/***********************************************************************************/
/**	\file				Teil1.cpp
**	\brief				Implementation globaler Funktionen
*************************************************************************************
**	Autor:				Christian Roesch
**
**	Erstelldatum:		27.03.2002
**	letzte Aenderung:	04.04.2002
*************************************************************************************
**	Die Hauptdatei zu Rechnernetze - Aufgabe 1 
**
************************************************************************************/

// Dokumentation Mainpage

/***********************************************************************************/
/*! \mainpage Rechnernetze - Aufgabe 1
**
**	\author	Christian Rsch
**
** Dieses Programm sendet oder empfngt eine Zeichenkette. 
**
** Es benutzt dazu die Klassen RNSocket und RNPacket.
** 
** Das Senden und Empfangen sind in den Klassen Sender und Receiver gekapselt.
** 
** In der Datei MessageGeneric.h finden sich die Definition der Messages, die
** verschickt werden.
************************************************************************************/

//includes
#include <stdio.h>
#include <conio.h>
#include <vector>

#include "Receiver.h"
#include "Sender.h"
#include "..\common\MessageGeneric.h"
#include "..\common\RNPacket.h"
#include "..\common\RNSocket.h"


//! globale Konstante fr den Port
const int g_iPort=9050;

/************************************************************************************
**	Funktion:			main
************************************************************************************/
/**	Der Einsprungpunkt des Programms
************************************************************************************/
int main(int argc, char* argv[])
{
	//Sockets initialisieren
	if (!RNSocket::init(1,1))
	{
		printf("Winsock could not be initialised!\n");
		return 1;
	}

	char pcEingabe[128];

	printf("(S)end or (R)eceive >");

	gets(pcEingabe);

	if (pcEingabe[0]=='S' || pcEingabe[0]=='s')
	{
		Sender	sndObj(g_iPort);
		sndObj.run();
	}

	if (pcEingabe[0]=='R' || pcEingabe[0]=='r')
	{
		Receiver	rcvObj(g_iPort);
		rcvObj.run();
	}

	//Sockets aufrumen
	if (!RNSocket::cleanUp())
	{
		return 1;
	}

	getch();

	return 0;
}

